# ::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
# Solution proposal to programming exercises week 6                   #
#                                                         #
# INF2310, spring 2017                                    #
#                                                         #
# Ole-Johan Skrede, 21.02.2017                            #
# ------------------------------------------------------- #
#                                                         #
# Based on an automatically generated script from the     #
# original ipython notebook solution proposal.            #
#                                                         #
# ::::::::::::::::::::::::::::::::::::::::::::::::::::::: #


# coding: utf-8

# # Solution to programming exercises week 6
# INF2310 spring 2017

import numpy as np
from scipy import signal


# ## Task 1

f = np.array([1, 3, 4, 3, 4])
w = np.array([1, 2, 1])

g_full = signal.convolve(f, w, mode='full')
g_valid = signal.convolve(f, w, mode='valid')
g_same = signal.convolve(f, w, mode='same')

print(g_full)
print(g_valid)
print(g_same)


# ## Task 2

f = np.array([[2, 5, 3, 1],
              [0, 2, 3, 3],
              [0, 7, 6, 3],
              [6, 0, 6, 5]])
w = np.ones((3, 3))

g_full = signal.convolve2d(f, w, mode='full')
g_valid = signal.convolve2d(f, w, mode='valid')
g_same = signal.convolve2d(f, w, mode='same')

print(g_full)
print(g_valid)
print(g_same)


# ## Task 3

w = np.ones((3, 3))/9
ww = signal.convolve(w, w, mode='full')
print(w*9)
print(ww*81)


# ## Task 5

f = np.array([[0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
              [0, 1, 0, 1, 1, 1, 1, 1, 0, 0],
              [0, 0, 0, 1, 0, 0, 0, 1, 0, 0],
              [0, 1, 0, 1, 0, 0, 0, 1, 0, 0],
              [0, 1, 0, 1, 0, 0, 0, 1, 0, 0],
              [0, 1, 0, 0, 1, 1, 1, 1, 1, 0],
              [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]])
print(f)

print(signal.medfilt(f, (3, 3)))
print(signal.medfilt(f, (1, 3)))
print(signal.medfilt(f, (3, 1)))


# ## Task 6

def special_median_filter(f):
    """Filter the input image with a special median filter such that

    g[x, y] = median{min(A_2(x,y), min(A_1(x, y), f[x, y], max(A_1(x, y), max(A_2(x, y)))))}

    where

    A_1(x, y) is the set of pixels at a distance 1 from (x, y) in a 8-connected neighbourhood of (x, y)
    A_2(x, y) is the set of pixels at a distance 1 from (x, y) in a 8-connected neighbourhood of (x, y)

    We ignore boundary pixels.

    Args:
        f: MxN numpy array.
    Returns:
        g: (M - 4)x(N - 4) numpy array.
    """

    M, N = f.shape
    g = np.zeros_like(f)
    for x in range(2, M-2):
        for y in range(2, N-2):
            A_1 = list(f[x-1, y-1:y+2]) + [f[x, y-1], f[x, y+1]] + list(f[x+1, y-1:y+2])
            A_2 = list(f[x-2, y-2:y+3]) + list(f[x+2, y-2:y+3]) +                   [f[x-1, y-2], f[x-1, y+2], f[x, y-2], f[x, y+2], f[x+1, y-2], f[x+1, y+2]]
            g[x, y] = np.median([np.min(A_2), np.min(A_1), f[x, y], np.max(A_1), np.max(A_2)] )

    return g[2:M-2, 2:N-2]


f = np.array([[0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 1, 1, 1, 1],
              [0, 0, 0, 0, 1, 1, 1, 1],
              [0, 0, 0, 0, 1, 1, 1, 1],
              [0, 0, 0, 0, 1, 1, 1, 1]])

g = special_median_filter(f)

print("f: \n", f)
print("g: \n", g)


f = np.array([[0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [1, 1, 1, 1, 1, 1, 1, 1],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0]])

g = special_median_filter(f)

print("f: \n", f)
print("g: \n", g)


f = np.array([[0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 1, 1, 1, 1],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0]])

g = special_median_filter(f)

print("f: \n", f)
print("g: \n", g)
